| <?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent">

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>

mixin utf
	u(format="char")
		block

// categories: std | bcp | info | exp | historic
rfc(category='std' number='2417685' consensus='false' ipr='trust200902' docName='ltc2984-driver-01' submissionType='be-cem-mro' xml:lang='en' version='3')
	front
		title(abbrev="LTC2984 Linux driver") Analog devices LTC2984 SPI Linux driver
		author(fullname='Mathieu Donze' initials='M.D.' role='editor' surname='Donze')
			organization CERN
			address
				postal
					street 1, Esplanade des Particules
					code 1217
					city Meyrin
					country Switzerland
				email mathieu.donze@cern.ch
		date(year='2019' month="June" day="03")

		keyword LTC2984

		abstract
			t This document describes the LTC2984 Linux driver and how to use it.

	middle
		section
			name Introduction
			t
				| The #[xref(target="LTC2984_WEBSITE") LTC2984] chip, manufactured by Analog devices (former Linear Technology), is a 
				| multi-Sensor high accuracy digital temperature measurement system with EEPROM.

		section(anchor="Features")
			name Chip features
			t
				| Here are the main features provided by this integrated circuit:
			ul
				li Directly Digitizes 2-, 3-, or 4-Wire RTDs, Thermocouples, Thermistors, and Diodes
				li On-chip EEPROM stores channel configuration data and custom coefficients
				li Single 2.85v to 5.25v supply
				li 20 flexible inputs allow interchanging sensors
				li Automatic thermocouple cold junction compensation
				li Built-in standard and user-programmable coefficients for thermocouples, RTDs and thermistors
				li Measures negative thermocouple voltages
				li Automatic burn out, short-circuit and fault detection
				li Buffered inputs allow external protection
				li Simultaneous 50Hz/60Hz rejection
				li Includes 15ppm/#[+utf °]C (Max) reference (I-Grade)
				
		section(anchor="IIO")
			name Linux Industrial I/O Subsystem
			t
				| For acquiring and configuring the LTC2984 chip, the #[xref(target="IIO_WEBSITE") Industrial I/O subsystem] present in Linux was used.
				| This subsystems allows triggered buffers reading and is easy to use.
				| An associated libiio library ease the developement of a client application.
		section
			name Kernel module compilation
			t
				| After getting #[xref(target="LTC2984_SRC") sources] of the driver, simply compile on your machine with the #[tt make] command.
				| You must have #[tt kernel headers] package installed.
		section
			name Kernel module installation
			t
				| As this driver is a SPI device driver, no automatic probing and detection of devices present is possible.
				| The SPI master must declare a #[tt ltc2984] device. Of course, this module needs to be loaded in the kernel, by using the #[tt insmod] command
				| for example.
				| A IRQ line connected to #[tt INTERRUPT] pin of the chip is needed. The interrupt must occurs when a rising edge is made on the pin.
				| (transition from #[tt busy] to #[tt done]). IRQ is specified when declaring the #[tt spi_board_info] structure (in the parent device).
		section
			name Configuration using SYSFS
			t
				| in addition to the standard SYSFS interface provided by IIO, extra attributes are exposed. 
				| Attributes are found in the same folder exposing IIO attributes. Typical path should be :
			figure
				name SYSFS path
				sourcecode
					| /sys/bus/spi/drivers/ltc2984/spi&lt;X.Y&gt;/iio:device&lt;Z&gt;
			t
				| These attributes are used for configuring input channels. Depending on how the channel is configured, the driver will expose some
				| attributes. A common attribute #[tt _sensor_type] is used to set the type of input connected to the specified channel.
				| You can get a list of supported input type by reading the #[tt in_temp_sensor_type_available] attribute.
			table(align='center')
				name Input type enumeration values
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td Unassigned
						td N/A
						td Channel is not used
					tr
						td Thermocouple_J
						td Thermocouple
						td J type thermocouple
					tr
						td Thermocouple_K
						td Thermocouple
						td K type thermocouple
					tr
						td Thermocouple_E
						td Thermocouple
						td E type thermocouple
					tr
						td Thermocouple_N
						td Thermocouple
						td N type thermocouple
					tr
						td Thermocouple_R
						td Thermocouple
						td R type thermocouple
					tr
						td Thermocouple_S
						td Thermocouple
						td S type thermocouple
					tr
						td Thermocouple_T
						td Thermocouple
						td T type thermocouple
					tr
						td Thermocouple_B
						td Thermocouple
						td B type thermocouple
					tr
						td Thermocouple_custom
						td Thermocouple
						td Custom thermocouple #[strong UNSUPPORTED]
					tr
						td RTD_PT-10
						td RTD
						td RTD PT-10
					tr
						td RTD_PT-50
						td RTD
						td RTD PT-50
					tr
						td RTD_PT-100
						td RTD
						td RTD PT-100
					tr
						td RTD_PT-200
						td RTD
						td RTD PT-200
					tr
						td RTD_PT-500
						td RTD
						td RTD PT-500
					tr
						td RTD_PT-1000
						td RTD
						td RTD PT-1000
					tr
						td RTD_1000
						td RTD
						td RTD 1000 (0.00375)
					tr
						td RTD_NI-120
						td RTD
						td RTD NI-120
					tr
						td RTD_custom
						td RTD
						td Custom RTD #[strong UNSUPPORTED]
					tr
						td Thermistor_44004_44033
						td Thermistor
						td Thermistor 44004/44033 2.252k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_44005_44030
						td Thermistor
						td Thermistor 44005/44030 3k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_44007_44034
						td Thermistor
						td Thermistor 44007/44034 5k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_44006_44031
						td Thermistor
						td Thermistor 44006/44031 10k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_44008_44032
						td Thermistor
						td Thermistor 44008/44032 30k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_YSI_400
						td Thermistor
						td Thermistor YSI 400 2.252k#[+utf Ω] at 25#[+utf °]C
					tr
						td Thermistor_Spectrum_1003k
						td Thermistor
						td Thermistor Spectrum 1003k 1k#[+utf Ω]
					tr
						td Thermistor_Custom_Steinhart-Hart
						td Thermistor
						td Thermistor Custom Steinhart-Hart
					tr
						td Thermistor_Custom_Table
						td Thermistor
						td Thermistor Custom Table #[strong UNSUPPORTED]
					tr
						td Diode
						td Diode
						td Diode
					tr
						td Sense_Resistor
						td Sense
						td Sense Resistor
					tr
						td Direct_ADC
						td ADC
						td Direct ADC
			t
				| Depending on the type of sensor declared some attributes will appear for finishing the configuration.
				| Here is the list of settings for thermocouple sensor type:
			table(align='center')
				name Thermocouple sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td cold_junction
						td Integer
						td Cold junction channel number (1 to 20). Zero means #[em No Cold Junction Compensation, 0C Used for Calculations].
					tr
						td input_type
						td Enumeration (#[tt DIFF, SGL])
						td Input type. #[tt DIFF] for differential. #[tt SGL] for single-ended.
					tr
						td oc_current
						td Enumeration (#[tt External, 10uA, 100uA, 500uA, 1mA])
						td Open circuit current. #[tt External] disable this feature.
			t
				| Possible configuration for RTD sensors :
			table(align='center')
				name RTD sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td r_sense
						td Integer
						td Sense resistor channel pointer (0 and 1 are #[strong INVALID])
					tr
						td num_wires
						td Enumeration (#[tt 2_wires, 3_wires, 4_wires, 4_wires_k_rsense])
						td Number of wires used for measurements. #[tt 4_wires_k_rsense] is for 4 wires Kelvin.
					tr
						td excit_mode
						td Enumeration (#[tt external, internal, internal_rot])
						td Excitation current mode. #[tt internal_rot] activates current source rotation and works only in 4 wires mode.
					tr
						td excit_current
						td Enumeration (#[tt reserved, 5uA, 10uA, 25uA, 50uA, 100uA, 250uA, 500uA, 1mA])
						td Excitation current. #[tt internal_rot] activates current source rotation and works only in 4 wires mode.
					tr
						td curve
						td Enumeration (#[tt european, american, japanese, ITS-90])
						td RTD curve, this set the corresponding Callendar-Van Dusen constants.
			t
				| Possible configuration for thermistor sensors :
			table(align='center')
				name Thermistor sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td r_sense
						td Integer
						td Sense resistor channel pointer.
					tr
						td input_type
						td Enumeration (#[tt DIFF, SGL])
						td Input type. #[tt DIFF] for differential. #[tt SGL] for single-ended.
					tr
						td excit_current
						td Enumeration (#[tt reserved, 250nA, 500nA, 1uA, 5uA, 10uA, 25uA, 50uA, 100uA, 250uA, 500uA, 1mA, auto])
						td Excitation current.
			t
				| Possible configuration for diode sensors :
			table(align='center')
				name Diode sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td input_type
						td Enumeration (#[tt DIFF, SGL])
						td Input type. #[tt DIFF] for differential. #[tt SGL] for single-ended.
					tr
						td meas_algo
						td Enumeration (#[tt 2_readings, 2_readings_avg, 3_readings, 3_readings_avg])
						td Measurement algorithm. Used to reduce the noise.
					tr
						td excit_current
						td Enumeration (#[tt 10uA, 20uA, 40uA, 80uA])
						td Excitation current.
					tr
						td ideality_factor
						td Floating point.
						td Non-Ideality Factor. Value from 0 to 4 with a 1/1048576 resolution. A value of 0 uses a factory set default of 1.003.
			t
				| Possible configuration for sense resistor sensors :
			table(align='center')
				name Sense resistor sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td sense_r_value
						td Floating point
						td Value of the sense resitor in #[+utf Ω]s, up to 131072#[+utf Ω]s with 1/1024 resolution.
			t
				| Possible configuration for direct ADC measurement :
			table(align='center')
				name Sense resistor sensor settings
				thead
					tr
						th Name
						th Type
						th Description
				tbody
					tr
						td input_type
						td Enumeration (#[tt DIFF, SGL])
						td Input type. #[tt DIFF] for differential. #[tt SGL] for single-ended.
			t
			t
				| Here is an example of how to configure 4 PT-100 sensors with one 10k#[+utf Ω] sense resistor:
			figure
				name Configuration example.
				sourcecode
					| echo Sense_Resistor > /sys/bus/iio/devices/iio:device0/in_temp3_sensor_type
					| echo 10000 > /sys/bus/iio/devices/iio:device0/in_temp3_sense_r_value
					| echo RTD_PT-100 > /sys/bus/iio/devices/iio:device0/in_temp5_sensor_type
					| echo 3 > /sys/bus/iio/devices/iio:device0/in_temp5_r_sense
					| echo 4_wires > /sys/bus/iio/devices/iio:device0/in_temp5_num_wires
					| echo internal > /sys/bus/iio/devices/iio:device0/in_temp5_excit_mode
					| echo 100uA > /sys/bus/iio/devices/iio:device0/in_temp5_excit_current
					| echo RTD_PT-100 > /sys/bus/iio/devices/iio:device0/in_temp8_sensor_type
					| echo 3 > /sys/bus/iio/devices/iio:device0/in_temp8_r_sense
					| echo 4_wires > /sys/bus/iio/devices/iio:device0/in_temp8_num_wires
					| echo internal > /sys/bus/iio/devices/iio:device0/in_temp8_excit_mode
					| echo 100uA > /sys/bus/iio/devices/iio:device0/in_temp8_excit_current
					| echo RTD_PT-100 > /sys/bus/iio/devices/iio:device0/in_temp11_sensor_type
					| echo 3 > /sys/bus/iio/devices/iio:device0/in_temp11_r_sense
					| echo 4_wires > /sys/bus/iio/devices/iio:device0/in_temp11_num_wires
					| echo internal > /sys/bus/iio/devices/iio:device0/in_temp11_excit_mode
					| echo 100uA > /sys/bus/iio/devices/iio:device0/in_temp11_excit_current
					| echo RTD_PT-100 > /sys/bus/iio/devices/iio:device0/in_temp14_sensor_type
					| echo 3 > /sys/bus/iio/devices/iio:device0/in_temp14_r_sense
					| echo 4_wires > /sys/bus/iio/devices/iio:device0/in_temp14_num_wires
					| echo internal > /sys/bus/iio/devices/iio:device0/in_temp14_excit_mode
					| echo 100uA > /sys/bus/iio/devices/iio:device0/in_temp14_excit_current
		section
			name Readout using SYSFS
			t
				| You can directly start a direct conversion on the desired channel by reading the #[tt _raw] attribute
				| associated with the channel. #[tt Unassigned] and #[tt Sense_Resistor] types are not supported by this and will 
				| return -EINVAL (invalid) error. A tentative to read this attribute when the buffered readout is active will
				| fail with a -EBUSY (busy) error.
				| The value read is encoded as a signed integer value (24 bits). 
				| To scale the value to the physical unit #[+utf °]C, you can read the #[tt in_temp_scale] attribute and multiply the value read.
				| For example, to read the channel 5: 
			figure
				name Read value using SYSFS
				sourcecode
					| echo `cat in_temp4_raw`*`cat in_temp_scale` | bc -l
			t
				| It will gives you the temperature in #[+utf μ]C. For example, if the raw value is 26240 and the scale 0.976562, 
				| the result will be 25624.98 (26240 * 0.976562).
				| So about 25.62#[+utf °]C.
			t
				| A #[tt fault] attribute is also available for each channel.
				| This attribute exposes an enumeration depending on present faults.
				| Faults are read from the data output registers, bits 25 to 31. An empty string means not fault is active.
			table(align='center')
				name Fault possible values
				thead
					tr
						th Name
						th Bit #
						th Description
				tbody
					tr
						td Hard_Fault
						td 31
						td Sensor hard fault. Bad sensor reading.
					tr
						td Hard_ADC_OOR
						td 30
						td Hard ADC-out-of-range. Bad ADC reading (could be large external noise event)
					tr
						td CJ_Hard_Fault
						td 29
						td Cold junction sensor has a hard fault error.
					tr
						td CF_Soft_Fault
						td 28
						td Cold junction sensor result is beyond normal range.
					tr
						td SOR
						td 27
						td Sensor reading is above normal range.
					tr
						td SUR
						td 26
						td Sensor reading is below normal range.
					tr
						td ADC_OOR
						td 25
						td ADC absolute input voltage is beyond ±1.125 • VREF/2.
		section
			name Buffered reading
			t
				| The driver implements a triggered ring buffer to perform conversion of ADC channels based on a defined trigger.
				| This implementation is standard to IIO subsystem and is not fully detailled here.
				| When using buffered reading, the multiple conversion mechanism provided by the chip is used (refer to the #[xref(target="LTC2984_DS") datasheet]).
				| Basically, the chip will start conversion consecutively on selected channels. After this conversion cycle is completed, the result will be transfered
				| to the IIO buffer. Only one interruption will be raised.
		section
			name Debugging
			t Some facilities are included in the driver to perform some debug operations.
			t
				| Some dynamic debug traces are used in important code portions.
				| You can activate these traces by using #[xref(target="DYN_DEBUG") dynamic debug] kernel facilities.
				| For example, you can active the whole module debug by using this command line
			figure
				name Activating dynamic debug for the complete module.
				sourcecode
					| echo 'module ltc2984 +p' > /sys/kernel/debug/dynamic_debug/control
			t In the example above, we assume #[tt /sys/kernel/debug] is the debugfs mount point.
			t On the contrary, you can disable debug traces by using:
			figure
				name Disabling dynamic debug for the whole module.
				sourcecode
					| echo 'module ltc2984 -p' > /sys/kernel/debug/dynamic_debug/control
			t
				| IIO provides also a mechanism to direct read and write registers.
				| This functionnality is fully implemented by the LTC2984 kernel module.
				| By using SYSFS (or IIO utility iio_reg), you can read and write chip registers.
				| Read and write transfers are 8 bit wide.
			t Here is an example to read the #[tt command status] register (address 0x0). We assume the IIO device name is #[tt iio:device0].
			figure
				name Reading a register.
				sourcecode
					| echo 0x0 > /sys/kernel/debug/iio/iio\:device0/direct_reg_access
					| cat /sys/kernel/debug/iio/iio\:device0/direct_reg_access
			t You can also perform a write to a register by specifying the value to be written.
			figure
				name Writing a register. Put device sleep mode.
				sourcecode
					| echo 0x0 0x8b > /sys/kernel/debug/iio/iio\:device0/direct_reg_access
	back
		references
			name References
			references
				name URL References
				reference(anchor='LTC2984_WEBSITE' target='https://www.analog.com/en/products/ltc2984.html')
					front
						title Analog devices TLC2984 product page.
						author
							organization Analog devices
				reference(anchor='LTC2984_DS' target='https://www.analog.com/media/en/technical-documentation/data-sheets/2984fb.pdf')
					front
						title Analog devices TLC2984 datasheet.
						author
							organization Analog devices							
				reference(anchor='IIO_WEBSITE' target='https://www.kernel.org/doc/html/latest/driver-api/iio/index.html')
					front
						title Linux industrial I/O subsystem.
						author
							organization The Linux Fundation
				reference(anchor='LTC2984_SRC' target='https://gitlab.cern.ch/apc/controls/sambuca/ltc2984')
					front
						title TLC2984 kernel module
						author
							organization CERN						
				reference(anchor='DYN_DEBUG' target='https://www.kernel.org/doc/html/latest/admin-guide/dynamic-debug-howto.html')
					front
						title TLC2984 kernel module
						author
							organization The Linux Fundation							
		section
			name Change Log
			t First version

